(* $Id: rawBytePervasives.mli,v 1.1 2004/04/06 22:12:40 yori Exp $ *)
(* Copyright 2002, 2003 Yamagata Yoriyuki. distributed with LGPL *)

module type Type = sig
  val open_out : string -> out_channel
  val open_out_gen : 
    open_flag list -> int -> string -> out_channel
  val flush : out_channel -> unit
  val output_char : out_channel -> char -> unit
  val output_string : out_channel -> string -> unit
  val close_out : out_channel -> unit

  val open_in : string -> in_channel
  val open_in_gen : open_flag list -> int -> string -> in_channel
  val input_char : in_channel -> char
  val input_line : in_channel -> string

  val stdin : in_channel
  val stdout : out_channel
  val stderr : out_channel

  val print_char : char -> unit
  val print_string : string -> unit
  val print_endline : string -> unit
  val print_newline : unit -> unit
    
  val prerr_char : char -> unit
  val prerr_string : string -> unit
  val prerr_endline :  string -> unit
  val prerr_newline : unit -> unit

  val read_line : unit -> string

  val (^) : string -> string -> string
end
